class Vec {
  constructor(x, y) {
    this.x = x; this.y = y;
  }
  plus(other) {
    return new Vec(this.x + other.x, this.y + other.y);
  }
  times(factor) {
    return new Vec(this.x * factor, this.y * factor);
  }
}

//============================================

class Attack {
  constructor(pos, speed, ch) {
    this.pos = pos;
    this.speed = speed;
    this.ch = ch;
  }

  get type() {return "attack " + this.ch +" tennisball"}

  static create(pos, ch) {
    return new Attack(pos, new Vec(-3, 0), ch);
  }
}

Attack.prototype.size = new Vec(1, 1);

class CandentisVAttack {
  constructor(pos, speed, ch) {
    this.pos = pos;
    this.speed = speed;
    this.ch = ch;
    this.dir = true;
  }

  get type() {return "attack " + this.ch + " line candentis"}

  static create(pos, ch) {
    return new CandentisVAttack(pos, new Vec(0, 3), ch);
  }
}

CandentisVAttack.prototype.size = new Vec(1, 1);

class CandentisAttack {
  constructor(pos, speed, ch) {
    this.pos = pos;
    this.speed = speed;
    this.ch = ch;
    this.dir = true;
  }

  get type() {return "attack " + this.ch +" candentis"}

  static create(pos, ch) {
    return new CandentisAttack(pos, new Vec(-3, 0), ch);
  }
}

CandentisAttack.prototype.size = new Vec(1, 1);

class RockAttack {
  constructor(pos, speed, ch) {
    this.pos = pos;
    this.speed = speed;
    this.ch = ch;
  }

  get type() {return "attack " + this.ch + " rock line"}

  static create(pos, ch) {
    return new RockAttack(pos, new Vec(0, 2), ch);
  }
}

RockAttack.prototype.size = new Vec(1,1)

class PizzaAttack {
  constructor(pos, speed, ch) {
    this.pos = pos;
    this.speed = speed;
    this.ch = ch;
  }

  get type() {return "attack " + this.ch +" pizza"}

  static create(pos, ch) {
    return new PizzaAttack(pos, new Vec(-1, 0), ch);
  }
}

PizzaAttack.prototype.size = new Vec(1, 1);

class BounceProjectile {
  constructor(pos, speed) {
    this.pos = pos;
    this.speed = speed;
  }

  get type() {return "projectile bounce tennisball"}

  static create(pos) {
    return new BounceProjectile(pos, new Vec(-4, Math.random() * 10 - 5))
  }
}

BounceProjectile.prototype.size = new Vec(1,1)

class SporkProjectile {
  constructor(pos, speed) {
    this.pos = pos;
    this.speed = speed;
    console.log(this.speed)
    this.angle = this.speed == undefined ? 0 : Math.atan(this.speed.y / this.speed.x)
  }

  get type() {return "projectile spork rotatey"}

  static create(pos) {
    let speed = new Vec(-6, Math.random() * -5 - 1)
    return new SporkProjectile(pos, speed)
  }
}

SporkProjectile.prototype.size = new Vec(2, 1)

class Line {
  constructor(pos, speed) {
    this.pos = pos;
    this.speed = speed;
  }

  get type() {return "line projectile rock"}

  static create(pos) {
    return new Line(pos, new Vec(0, 3))
  }
}

Line.prototype.size = new Vec(1,1)

class SineAttack {
  constructor(pos, speed, ch, wobble) {
    this.pos = pos;
    this.speed = speed;
    this.ch = ch;
    this.wobble = wobble;
  }

  get type() {return "attack " + this.ch + " tennisball"}

  static create (pos, ch) {
    return new SineAttack(pos, new Vec(-3, 0), ch, Math.random() * Math.PI * 5)
  }
}

SineAttack.prototype.size = new Vec(1, 1);

class BigSpork {
  constructor(pos, speed) {
    this.pos = pos;
    this.speed = speed;
    this.timer = 0
    this.warning = true;
  }

  get type() {return "projectile fast spork"}

  static create(pos) {
    return new BigSpork(pos, new Vec(0, 0))
  }
}

BigSpork.prototype.size = new Vec(9,9)