/*
Credits:
Thank you for the free content!
https://eloquentjavascript.net/16_game.html
Music: Underglow by Shane Ivers - https://www.silvermansound.com
Music: Dire Space Emergency by Shane Ivers - https://www.silvermansound.com
Reformat Kevin MacLeod (incompetech.com)
Licensed under Creative Commons: By Attribution 3.0 License
http://creativecommons.org/licenses/by/3.0/
@Shades
https://soundcloud.com/noshades
Music: Play The Game by Shane Ivers - https://www.silvermansound.com
Music: Set it Up by Shane Ivers - https://www.silvermansound.com
Music: Cheeky by Shane Ivers - https://www.silvermansound.com
Music: Smash it by Shane Ivers - https://www.silvermansound.com
Music: Dubstep Damage by Shane Ivers - https://www.silvermansound.com
Music: Cheese Greater by Shane Ivers - https://www.silvermansound.com 
Where Are We? by Artificial.Music | https://soundcloud.com/artificial-music
Music promoted by https://www.free-stock-music.com
Creative Commons Attribution 3.0 Unported License
https://creativecommons.org/licenses/by/3.0/deed.en_US
Halloween Theme 1 by Alexander Nakarada | https://www.serpentsoundstudios.com
Music promoted by https://www.free-stock-music.com
Attribution 4.0 International (CC BY 4.0)
https://creativecommons.org/licenses/by/4.0/
*/
//Save Codes
let codes = ["49666", "60133", "80038", "32587"]

//Text for Tutorial box
let tutorialText = [
  "Petros! It's great to see a familiar face. You're late too?<br>Oh no, I know that face, you're testing me again... 'Have to be prepared for anything'<br><br>Practice moving around the area with ARROW KEYS to start, and get ready!",
  "Here comes the challenge...<br>Dodge the Projectiles falling from the sky with the ARROW KEYS.<br>You can also use WASD to help your movement.",
  "Keep it up! There's more coming!<br><br>Remember, ARROW KEYS and WASD.",
  "Stay awake! It's only the beginning.<br><br>Projectiles with arrows are Attacks. I need to block these Attacks. Use WASD to match each Attack's direction.<br><br>↑W ↓S ←A →D",
  "Keep it up! There's more coming!<br>Missing an Attack will make you lose health.<br><br>↑W ↓S ←A →D",
  "Okay, one more!<br>Attacks also give you Power to make Counterattacks!<br><br>↑W ↓S ←A →D",
  "Now for the fun part! It's your turn!<br/>Aim and press A and D to launch a Horizontal Counterattack.<br/>Make sure to have some power.<br/>Your attacks will be faster and more powerful with more Power.<br><br>↠A+D",
  "It's almost over!<br>Now press W and S to launch a Vertical Counterattack.<br>It's harder to aim, but does double damage. Remember to collect Power!<br><br>↡W+S",
  "Looks like he's getting tired...<br>And that's it for the tutorial!"
]

//Textures to preload
let textureData = ["./Textures/Background.png", "./Textures/Dialogue.png", "./Textures/Event.png", "./Textures/HP.png", "./Textures/Power.png", "./Textures/Wall.png", "./Textures/TennisballL.png", "./Textures/TennisballR.png", "./Textures/TennisballU.png", "./Textures/TennisballD.png", "./Textures/TennisballRed.png", 
"./Textures/Bubble.png", "./Textures/RockL.png", "./Textures/RockR.png", "./Textures/RockU.png", "./Textures/RockD.png", "./Textures/RockRed.png", "./Textures/Stairs.png", "./Textures/Spork.png", "./Textures/BigSpork (2).png", "./Textures/PizzaU.png", "./Textures/PizzaD.png", "./Textures/PizzaL.png", "./Textures/PizzaR.png", "./Textures/CandentisU.png", "./Textures/CandentisD.png","./Textures/CandentisL.png","./Textures/CandentisR.png", "./Textures/CandentisVU.png", "./Textures/CandentisVD.png","./Textures/CandentisVL.png","./Textures/CandentisVR.png"]

//Menu images to preload
let menuData = ["./Menu/Gameover3Face.png",
"./Menu/GameoverText.png", 
"./Menu/Icon.png",
"./Menu/Logo.png",
"./Menu/Sawfish Team New.png",
"./Menu/LindorBanner.png", "./Menu/PetrosBanner.png", "./Menu/SporkyBanner.png", "./Menu/RufusBanner.png", "./Menu/SAGE22MONOAM2U2EDINVERTED.png"]

//Animation values
let walkingFrames = 4;

let jumpFrame = 5
let fallFrame = 6
let upFrame = 7
let leftrightFrame = 8
let downFrame = 9

let eJumpFrame = 3

//Animation frame lists
let walkingSpriteData = {
  "Aysel": 
  ["./Sprites/Aysel/AyselWalkingIdle.png", "./Sprites/Aysel/AyselWalking1.png", "./Sprites/Aysel/AyselWalking2.png", "./Sprites/Aysel/AyselWalking1.png", "./Sprites/Aysel/AyselWalking3.png", "./Sprites/Aysel/AyselJump.png", "./Sprites/Aysel/AyselFall.png", "./Sprites/Aysel/AyselU.png", "./Sprites/Aysel/AyselLR.png", "./Sprites/Aysel/AyselD.png"],
  "Lindor":
  ["./Sprites/Lindor/LindorIdle.png",
  "./Sprites/Lindor/LindorAttack2.png",
  "./Sprites/Lindor/LindorAttack1.png",
  "./Sprites/Lindor/LindorJump.png"],
  "Petros":
    ["./Sprites/Petros/PetrosIdle.png", 
    "./Sprites/Petros/PetrosAttack2.png",
    "./Sprites/Petros/PetrosAttack1.png",
    "./Sprites/Petros/PetrosJump.png"],
  "Sporky" : 
    ["./Sprites/Sporky/SporkyIdle.png",
    "./Sprites/Sporky/SporkyAttack2.png",
    "./Sprites/Sporky/SporkyAttack1.png",
    "./Sprites/Sporky/SporkyJump.png"],
  "Rufus": [
    "./Sprites/Rufus/RufusIdle.png",
    "./Sprites/Rufus/RufusAttack2.png",
    "./Sprites/Rufus/RufusAttack1.png",
    "./Sprites/Rufus/RufusJump.png",
  ]
}

//Text to be presented at credits
let creditsData = [
  "Created, Coded, Illustrated, and Written By: Full Sawfish",
  "SAGE 2022 Logo: P3DRO, RummySM",
  "♢",
  "Code Based On: Marijn Haverbeke's Eloquent Javascript Chapter 16 Project: A Platform Game",
  "",
  "",
  "Inspired By: Trinitroid's Mekanikko (aka Sonic and the Mayhem Master)",
  "",
  "",
  "Silverman Sound Music:",
  "<u><b>https://www.silvermansound.com</u></b>",
  "Music: Underglow by Shane Ivers",
  "Music: Dire Space Emergency by Shane Ivers",
  "Music: Play The Game by Shane Ivers",
  "Music: Cheese Greater by Shane Ivers",
  "Music: Set It Up by Shane Ivers",
  "Music: Cheeky by Shane Ivers [to be used]",
  "Music: Smash It by Shane Ivers [to be used]",
  "Music: Dubstep Damage by Shane Ivers",
  "♢",
  "Incompetech.com Music:",
  "Licensed under Creative Commons: By Attribution 3.0 License",
  "http://creativecommons.org/licenses/by/3.0/",
  "Music: Reformat by Kevin MacLeod",
  "♢",
  "Free-Stock-Music.com Music:",
  "Music: Halloween Theme 1 by Alexander Nakarada",  
  "https://www.serpentsoundstudios.com",
  "Music promoted by https://www.free-stock-music.com",
  "Attribution 4.0 International (CC BY 4.0)",
  "https://creativecommons.org/licenses/by/4.0/",
  "Music: Where Are We? by Artificial.Music", 
  "https://soundcloud.com/artificial-music",
  "Music promoted by https://www.free-stock-music.com",
  "Creative Commons Attribution 3.0 Unported License",
  "https://creativecommons.org/licenses/by/3.0/deed.en_US",
  "",
  "",
  "OpenGameArt.org Sound Effects:",
  "Sound Effects: 8-Bit Sound Effect Pack (Vol. 001) by @Shades",
  "",
  "",
  "Join Sawfish Team and check the Headmaster Disaster website for updates and information",
  "<u><b>https://headmaster-disaster.glitch.me</b></u>",
  "♢♢♢",
  "",
  "",
  "If you're intersted in other independent games, check out GameJolt, Itch.io, or Sonic Fan Games HQ's annual Sonic Amateur Games Expo and explore!",
  "",
  "Thank you for playing!"
]

//URL for favicon
let iconURL = "Menu/Icon.png"

let dialogueDataII = [
  {
    "character": "test",
    "expression": "normal",
    "text": "e"
  },
  {
    "character": "test",
    "expression": "normal",
    "text": "e"
  }
]

let dialogueOof = [
  {
    "character": "Petros",
    "expression": "worried",
    "text": "It's all dark and spooky in here now the lights are off, it's almost like anything can happen at any"
  },
  {
    "character": "SoundEffect",
    "sound": "enemybanner"
  },
  {
    "character": "Aysel",
    "expression": "scared",
    "text": "...                              Why are you laughing? Oh, really!? Don't do that!"
  },
  {
    "character": "Petros",
    "expression": "haha",
    "text": "Sorry, I just had to."
  }
]

let dialogueBing = [
  {
    "character": "Petros",
    "expression": "normal",
    "text": "Honestly, this beats doing another Bing Webquest."
  },
  {
    "character": "Aysel",
    "expression": "unimpressed",
    "text": "I don't see you doing the fighting..."
  }
]

let dialogueSpork = [
  {
    "character": "Aysel",
    "expression": "surprised",
    "text": "Sporky!? What are you doing here? Could you let us through, it's urgent"
  },
  {
    "character": "Petros",
    "expression": "worried",
    "text": "Yeah, like really, really urgent!"
  },
  {
    "character": "Sporky",
    "expression": "smug",
    "text": "No...",
  },
    {
    "character": "Sporky",
    "expression": "smug",
    "text": "I have special orders.",
  }
]

let dialogueLindor = [
  {
    "character": "Aysel",
    "expression": "normal",
    "text": "By the way, what did Mr. Lindor write back there?"
  },
  {
    "character": "Petros",
    "expression": "confused",
    "text": "It looked like 'Run' and he wrote it in The Old Language"
  },
  {
    "character": "Aysel",
    "expression": "worried",
    "text": "Oooookay... let's keep doing that"
  }
]

//Final game dialogue
let gameWinData = [
  {
    "character": "Petros", 
    "expression": "confused",
    "text": "Mr. Lindor's usually pretty chill... What's going on?"
  },
  {
    "character": "Aysel",
    "expression": "confused",
    "text": "I don't know what's going on, but the students aren't paying attention to this at all."
  },
  {
    "character": "Lindor",
    "expression": "oof",
    "text": "Urg... *struggles to get up*"
  },
  {
    "character": "Aysel",
    "expression": "scared",
    "text": "Is he going to attack again!?"
  },
  {
    "character": "Petros",
    "expression": "confused",
    "text": "No, he's writing something... on the ground?"
  },
  {
    "character": "Rufus",
    "expression": "shadow",
    "text": "[On the PA System] Good morning students and staff, this is your NEW principal speaking. I have received news that some students are misbehaving and causing some... issues. Because of this, I will be calling an end to First Period. Please transition to your next class, and remind your peers of our... expectations. That is all."
  },
  {
    "character": "Aysel",
    "expression": "worried",
    "text": "Well, here comes the crowd..."
  }
]

let gameWinDataSpork = [
  {
    "character": "Sporky",
    "expression": "worried",
    "text": "I lost...                How can that be? I've failed my task..."
  },
  {
    "character": "Aysel",
    "expression": "confused",
    "text": "Sporky, why did you attack us?               ...And why is Mr. Lindor not following us anymore..."
  },
  {
    "character": "Aysel",
    "expression": "angry",
    "text": "And what is even going on here!!!?"
  },
  {
    "character": "Sporky",
    "expression": "smug",
    "text": "I've already told you... And haven't you heard the announcement?             You've made him angry!"
  },
  {
    "character": "Petros",
    "expression": "confused",
    "text": "The Principal? Oh great, is everyone against us now?"
  },
  {
    "character": "Aysel",
    "expression": "angry",
    "text": "Why is this happening!!?"
  },
  {
    "character": "Sporky",
    "expression": "smug",
    "text": "Oh you'll find out soon enough...                Ack! *falls over* What? Okay, okay, I'll stop!"
  },
  {
    "character": "Petros",
    "expression": "worried",
    "text": "Was that you, Hazel?"
  },
  {
    "character": "Aysel",
    "expression": "surprised",
    "text": "No, it wasn't!                               "
  }
]

let gameWinDataRufus = [
  {
    "character": "Rufus",
    "expression": "angry",
    "text": "Why are you not like them...? Why didn't the Phosphorescent Mist work!?",
  },
  {
    "character": "Rufus",
    "expression": "worried",
    "text": "No... no... no no no. I had this all planned out, how could this happen!?"
  },
  {
    "character": "Rufus",
    "expression": "angry",
    "text": "Grrr... I had this plan, you see... Everything was perfect... And then you two showed up!"
  },
  {
    "character": "Aysel",
    "expression": "confused",
    "text": "Petros, do you know what's going on..."
  },
  {
    "character": "Petros",
    "expression": "confused",
    "text": "Nope, no idea whatsoever..."
  },
  {
    "character": "Aysel",
    "expression": "angry",
    "text": "Great, so first we're late and now this happens!? Next thing I know there will be aliens here!? I'm too tired to deal with all of this."
  },
  {
    "character": "Rufus",
    "expression": "angry",
    "text": "Oh, I see now, you weren't there... But I'll need more power, the school couldn't handle it. That's why it's so dark and-But where to find it, where to find it..."
  },
  {
    "character": "Petros",
    "expression": "confused",
    "text": "So umm, Mr. Principal,               we really should be getting to class, so we're just going to leave now.         If that's okay."
  },
  {
    "character": "SoundEffect",
    "sound": "stairs"
  },
  {
    "character": "Aysel",
    "expression": "normal",
    "text": "Hey, the lights came back!"
  },
  {
    "character": "Aysel",
    "expression": "unimpressed",
    "text": "Aaaaand, he's gone..."
  },
  {
    "character": "Full Sawfish",
    "expression": "normal",
    "text": "And that concludes the current demo. Thank you for playing! I hope you enjoyed!                               "
  }
]

//End of tutorial dialogue
let gameWinData2 = [
  {
    "character": "Petros",
    "expression": "haha",
    "text": "Ha! I got you so off guard this time!"
  },
  {
    "character": "Aysel",
    "expression": "worried",
    "text": "As annoying as that was, at least I won't be late to class alone."
  },
  {
    "character": "Petros",
    "expression": "normal",
    "text": "Let's go!"
  },
  {
    "character": "Aysel",
    "expression": "worried",
    "text": "I'm coming! We're not that late right...?                               "
  }
]

//Various dialogue squares
let dialogueStairs = [
  {
    "character": "Aysel",
    "expression": "normal",
    "text": "My first class is on the second floor, I'll have to go up these stairs."
  }
]

let dialogueLate = [
  {
    "character": "Aysel",
    "expression": "angry",
    "text": "It's the first day of school and I'm already late... I need to hurry up."
  }
]

let dialogueFrontDesk = [
  {
    "character": "Aysel",
    "expression": "confused",
    "text": "No, don't walk to the front desk... I need to get to class."
  }
]

let dialogueWindow = [
  {
    "character": "Aysel",
    "expression": "worried",
    "text": "No one's outside, no one's in the hallway... Now hurry up."
  }
]

let dialogueTutorial = [
  {
    "character": "Full Sawfish", 
    "expression": "normal",
    "text": "Game developer Full Sawfish here... The red square in front of you is the Tutorial against Petros. If you'd like to skip it, you may use the stairs behind it. Just make sure not to get too close to the Event. It will automatically activate!"
  }
]

let dialogueData = [
  {
    "character": "Full Sawfish",
    "expression": "normal",
    "text": "Welcome to Headmaster Disaster's first demo build! I'm Full Sawfish, the creator of the game. I'll be telling you how to play. First, as you must have figured out, the ARROW KEYS are used for movement. You can press E to interact with dialogue squares. The square with an ! is a battle or event. It will be triggered when you run into it. In the battle, controls are similar. ARROW KEYS are used to move, and WASD are used to attack projectiles, missing projectiles will lower your health. Be sure to dodge the red ones though. Press A and D to perform a horizontal counterattack. Press W and S to perform a vertical counterattack. Vertical counterattacks do more damage than horizontal ones. More power in your power bar will result in stronger and faster counterattacks. Once the enemy's health is down to 0, the game ends."
  },
  {
    "character": "Full Sawfish",
    "expression": "haha", 
    "text": "It'll make more sense when you actually do it. Oh yeah, and press SPACE to exit dialogue..."
  }
]

let dialoguePreLoad = []

let characterData = {
  "Full Sawfish": {
    "normal": "./Sprites/Full Sawfish/SawfishFaces1.png",
    "haha": "./Sprites/Full Sawfish/SawfishFaces2.png"
  },
  "Aysel": {
    "normal": "./Sprites/Aysel/AyselHappy.png",
    "angry": "./Sprites/Aysel/AyselAngry.png",
    "confused": "./Sprites/Aysel/AyselConfused.png",
    "happier": "./Sprites/Aysel/AyselHappier.png",
    "sad": "./Sprites/Aysel/AyselSad.png",
    "scared": "./Sprites/Aysel/AyselScared.png",
    "worried": "./Sprites/Aysel/AyselWorried.png",
    "surprised": "./Sprites/Aysel/AyselSurprised.png",
    "unimpressed": "./Sprites/Aysel/AyselUnimpressed.png"
  },
  "Petros": {
    "normal": "./Sprites/Petros/PetrosHappy.png",
    "confused": "./Sprites/Petros/PetrosConfused.png",
    "haha": "./Sprites/Petros/PetrosHaha.png",
    "worried": "./Sprites/Petros/PetrosWorried.png"
  },
  "Lindor": {
    "normal": "./Sprites/Lindor/LindorHappy.png",
    "oof": "./Sprites/Lindor/LindorPain.png"
  },
  "Rufus": {
    "shadow": "./Sprites/Rufus/RufusShadow.png",
    "angry": "./Sprites/Rufus/RufusAngry.png",
    "worried": "./Sprites/Rufus/RufusWorried.png",
    "interested": "./Sprites/Rufus/RufusInterested.png",
  },
  "Sporky": {
    "smug": "./Sprites/Sporky/SporkySmug.png",
    "normal": "./Sprites/Sporky/SporkyNormal.png",
    "worried": "./Sprites/Sporky/SporkyWorried.png"
  }
}

for (let i = 0; i < Object.keys(characterData).length; i ++) {
  for (let j = 0; j < Object.keys(characterData[Object.keys(characterData)[i]]).length; j++) {
    let char = Object.keys(characterData)[i]
    let exp = Object.keys(characterData[Object.keys(characterData)[i]])[j]
    dialoguePreLoad.push(characterData[char][exp])
  }
}

let musicData = {
  "level": "./Music/dubstep-damage.mp3",
  "title": "./Music/dire-space-emergency.mp3",
  "gameover": "./Music/underglow.mp3",
  "banner": "./Music/play-the-game.mp3"
}

let soundEffectData = {
  "jump": "./SFX/Jump 1.wav",
  "attack": "./SFX/Hit 2.wav",
  "damage": "./SFX/Shoot 3.wav",
  "doublejump": "./SFX/Fly 3.wav",
  "tennisball": "./SFX/Shoot 2.wav",
  "counterattack": "./SFX/Shoot 1.wav",
  "maxpower": "./SFX/Powerup 1.wav",
  "enemybanner": "./SFX/Fly 2.wav",
  "cleardata": "./SFX/Powerup 2.wav",
  "nodata": "./SFX/Select 2.wav",
  "stairs": "./SFX/Exit 1.wav",
  "warning": "./SFX/Hit 5.wav",
  "button": "./SFX/Wrong 3.wav"
}